include <../base.scad>;
include <../servo/horn.scad>;
include <config.scad>;


module battery_strip_base(){
    translate(battery_offset)
        for(x=[
                -battery_dim[0]/2 - strip_t/2, 
                battery_dim[0]/2 + strip_t/2, 
                battery_dim[0]/2 + strip_t + t + strip_t/2
        ])
            translate([x, 0, 0])
                hull() for(y=[-strip_w/2, strip_w/2]){
                    translate([0, y, 0])
                        children();
                }
}
module battery_mount_neg(){
    battery_strip_base()
        cylinder(d=strip_t, h=10, center=true);
}
module battery_mount(){
    hull(){
        battery_strip_base()
            cylinder(d=strip_t + t*2, h=plate_t);
    }
}

module raspbi_neg(){
    raspbi_holes()
        cylinder(d=rpi_screw_d, h=10, center=true);
}


module raspbi_mount(){
    raspbi_holes()
        cylinder(d=rpi_screw_d + t*2, h=plate_t);
}



module bottom_plate() color("orange"){
    difference(){
        hull(){
            leg_pos() 
                horn_mount(2);
            battery_mount();
            raspbi_mount();
        }
        leg_pos()
            horn_hole(n=2) ;
        battery_mount_neg();
        raspbi_neg();
    }
}

bottom_plate();
