
use <../servo/sg9.scad>;
use <../servo/horn.scad>;
use <picam.scad>;
include <config.scad>;



module horn_holes(){
    
    cylinder(d=horn_d, center=true, h=1000);
    for(x=[horn_a, horn_b])
        translate([x, 0, -10])
            cylinder(d=horn_d2,h=1000, center=true); 
}

module holder() difference(){
    union(){
        hull(){
            cylinder(d = horn_d + t*2, h=camera_holder_t);
            for(pos=cam_screw_pos){
                translate([camera_x_offset -t , pos + camera_z_offset, 0])
                    cylinder(d = t*2, h=camera_holder_t);
                translate([camera_x_offset - cam_screw_h, pos + camera_z_offset, -camera_y_offset])
                    rotate([0, 90, 0])
                        cylinder(d=cam_screw_d + t*2, h=cam_screw_h);
            }
        }
    }
    
    hull(){
        for(x=[-100,camera_x_offset - t*2], z=[-t, -100])
        translate([x,0,z])
            rotate([90, 0, 0])
                cylinder(d=t*2, h=100, center=true);
    }
    
    for(pos=cam_screw_pos){
        translate([camera_x_offset - t, pos + camera_z_offset, -camera_y_offset])
            rotate([0, 90, 0])
                cylinder(d=cam_screw_d, h=100, center=true);
    }
    translate([ 0, 0, 6 + t])
        rotate([0, 0, horn_angle])
            horn_holes();
}

module base() difference(){
    hull() for(i=[-1,1]){
        translate([pi_y_offset, i*pi_screw_distance /2, 0])
            cylinder(d=pi_screw_d + t*2, h=t);
        cylinder(d=horn_d + t*2, h=t);
    }
    for(i=[-1,1]){
        translate([pi_y_offset, i*pi_screw_distance /2, 0])
            cylinder(d=pi_screw_d, h=100, center=true);
    }
    translate([0, 0, -9])
    for(a=[-90, 90])
        rotate([180, 0, a])
            horn_holes();
}

$fn=64;

module holder_with_servo() translate([0, -10, 0]){
    rotate([90, 0, 0])
    color("gray")
        holder();
    translate([camera_x_offset, camera_y_offset , camera_z_offset])
    translate([0.5, 10.5, 19])
        rotate([90, 0, 90])
            color("Green")
                raspberryPiCamera();

}

module camera_base(){
    

    translate([0, 0, t])
    rotate([180, 0, 90])    
        horn(2);    
    
    color("gray")
    base();
}

module camera_yaw(){
    rotate([180, 0, 0])
        mg90s();
    
    translate(pitch_offset) 
        rotate([90, 0 ,0])
            mg90s();
}

module camera_pitch(){
    holder_with_servo();
}


