
mg90s = dict(
            servo = dict(
                width = 12.5,
                length = 22.9,
                height = 22.9
                ),
            frame = dict(
                length = 32.2,
                thickness = 2.45,
                v_offset = 16
                ),
            mounting_hole = dict(
                diameter = 2,
                slot = 1
                ),
            turret = dict(
                diameter = 11.7,
                height = 5.2
                ),
            axle = dict(
                height = 3.9,
                diameter = 4.82,
                screw_diameter = 2
                ),
        )


servo_horn = dict(
            t = 2,
            h = 6,
            d = 7.1, # body d
            d2 = 2.5, # hole d
            a = 6.5, # first hole offset
            b = 12.5 # second hole offset
        )

mg90s["mounting_hole"]["center_x_offset"] = mg90s['servo']["width"]
mg90s["mounting_hole"]["center_y_offset"] = mg90s["mounting_hole"]["slot"] + mg90s["mounting_hole"]["diameter"]/2

mg90s["turret"]['x_margin'] = (mg90s['servo']['width'] - mg90s['turret']['diameter'] )/2
mg90s['turret']['y_margin'] = mg90s['servo']['length'] - mg90s['turret']['diameter']

mg90s['horn_offset'] = mg90s['turret']['height'] + mg90s['axle']['height'] + servo_horn['t']

mg90s['gimbal_vector'] = [
        -mg90s['turret']['diameter']/2,
        mg90s['servo']['width'],
        -(mg90s['servo']['length'] - mg90s['turret']['diameter']/2)
        ]

battery = dict(
            offset = [-5,0,0],
            dim = [80,12,35]
        )


legs = dict(
            fl = dict(
                pos=[30,25,0],
                rot=[0, 0, -15],
                mirror=[0,0,0]
                ),
            fr = dict(
                pos=[30,-25,0],
                rot=[0, 0, -165],
                mirror=[1,0,0]
                ),
            rl = dict(
                pos=[-30,25,0],
                rot=[0, 0, 15],
                mirror=[1,0,0]
                ),
            rr = dict(
                pos=[-30,-25,0],
                rot=[0, 0, 165],
                mirror=[0,0,0]
                ),
        )

rpi = dict(
        holes = dict(
                y=49,
                x=58
            ),
        offset = [-20,0,0],
        screw_d = 2.5,
        )


femur_arm = [0, 40, 0]
tibia_arm = [-5, 50, 0]
coxa_arm = [
        0,
        mg90s['servo']["width"],
        -(mg90s['servo']["length"] - mg90s["turret"]["diameter"]/2 + mg90s["turret"]["height"] + mg90s["axle"]["height"] + servo_horn["t"])
        ]
gimbal = dict(
            camera = dict(
                    x_offset = 25,
                    y_offset = 5.5,
                    z_offset = -21.5
                ),
            horn = dict(
                    d = 6, # horn hole d
                    a = servo_horn['a'],
                    b = servo_horn['b'],
                    d2 = servo_horn['d2'],
                    angle = -10,
                ),
            cam = dict(
                    screw = dict(
                        d = 2,
                        h = 4,
                        pos = [9.35, 21.85]
                    )
                ),
            clearance = 10,
            camera_holder_t = 3,
            t = 3,
            pi = dict(
                    screw_distance = rpi['holes']['y'],
                    screw_d = rpi['screw_d'],
                    y_offset = -2,
                )
        )

gimbal['yaw_offset'] = [0,0,mg90s['horn_offset'] + gimbal['t']]

gimbal['pitch_offset'] = [
        mg90s['gimbal_vector'][1]*-1,
        mg90s['gimbal_vector'][0],
        mg90s['gimbal_vector'][2]*-1,
    ]

base_plate = dict(
            t = 4,
            strip_t = 2,
            strip_w = 20,
            plate_t = 2
            
        )

strengthen = dict(
            t = 3,
            screw_d = 3,
            screw_offset = - mg90s['servo']['height'] - mg90s['mounting_hole']['center_y_offset'] - 0.7,
            k = 0.1,
            spacing = 1,
            h = 10,
        )

